/*******************************************************************************
 * FoxHoloMan_Base generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxHoloMan_Base extends Actor
    native
    notplaceable
    hidecategories(Navigation);

var() export editinline SkeletalMeshComponent LowerBodyMesh;
var() export editinline SkeletalMeshComponent UpperBodyMesh;
var() export editinline SkeletalMeshComponent HelmetMesh;
var() export editinline SkeletalMeshComponent TacticalMesh;
var() export editinline LightEnvironmentComponent LightEnvironment;
var int HoloPRIIndex;
var FoxPRI HoloPRI;
var ProfileGearInfo GearInfo;
var AnimTree AnimTreeTemplate;
var repnotify transient int HoloPRI_ID;
var transient AnimNodeSlot FullBodyAnimNode;
var transient AnimNodeSlot UpperBodyAnimNode;
var transient AnimNodeSlot LowerBodyAnimNode;
var() private name FullBodySlotName;
var() private name UpperBodySlotName;
var() private name LowerBodySlotName;
var export editinline transient FoxSkeletalMesh3rdPersonWeapon WeaponMesh;
var bool bIsStationary;
var transient bool bFinishedGrowing;
var bool bUseEmote;
var const float GrowTime;
var name FXBoneName;
var ParticleSystem SpawnInPS;
var ParticleSystem SpawnOutPS;
var PhysicalMaterial FXMaterial;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        HoloPRI_ID
}

simulated function ReplicatedEvent(name VarName)
{
    // End:0x2D
    if(VarName == 'HoloPRI_ID')
    {
        SetPRIbyID(HoloPRI_ID);
    }
    // End:0x40
    else
    {
        super.ReplicatedEvent(VarName);
    }
    //return;    
}

simulated function PostBeginPlay()
{
    super.PostBeginPlay();
    SetTimer(GrowTime, false, 'GrowTimer');
    SetTimer(LifeSpan - float(1), false, 'StartShrinking');
    SetOwner(none);
    //return;    
}

simulated function GrowTimer()
{
    // End:0x4A
    if(!bFinishedGrowing)
    {
        LowerBodyMesh.SetScale3D(vect(1.0, 1.0, 1.0));
        bFinishedGrowing = true;
    }
    // End:0xF2
    else
    {
        LowerBodyMesh.SetHidden(true);
        UpperBodyMesh.SetHidden(true);
        HelmetMesh.SetHidden(true);
        TacticalMesh.SetHidden(true);
        LowerBodyMesh.DetachComponent(WeaponMesh);
    }
    //return;    
}

simulated function StartShrinking()
{
    bFinishedGrowing = true;
    SetTimer(GrowTime, false, 'GrowTimer');
    // End:0x92
    if(WorldInfo.MyEmitterPool != none)
    {
        WorldInfo.MyEmitterPool.SpawnEmitter(SpawnOutPS, Location,, self);
    }
    //return;    
}

simulated function SetPRIbyID(int PRIID)
{
    local FoxPawn FP;

    // End:0x96
    if(((HoloPRI == none) && WorldInfo.GRI != none) && PRIID >= 0)
    {
        HoloPRI = FoxGRI(WorldInfo.GRI).GetPRIByPlayerID(PRIID);
    }
    // End:0x11F
    if(Instigator == none)
    {
        // End:0x11E
        foreach WorldInfo.AllPawns(class'FoxPawn', FP)
        {
            // End:0x11D
            if(FP.PlayerReplicationInfo == HoloPRI)
            {
                Instigator = FP;
                // End:0x11E
                break;
            }            
        }        
    }
    SetPRI(HoloPRI);
    //return;    
}

simulated function SetPRI(FoxPRI NewPRI)
{
    local FoxPawn FP;
    local FoxDataStore_Unlockables UnlockablesDataStore;
    local FoxDataProvider_GearInfo GearInfoProvider;
    local FoxDataProvider_Avatar AvatarProvider;
    local AnimNodeSlot Node;
    local int I, AnimCount;
    local class<FoxWeaponAttachment> AttachmentClass;
    local array<AnimSet> AnimSetArray;

    // End:0x37
    if(NewPRI != none)
    {
        HoloPRI_ID = NewPRI.PlayerID;
    }
    FP = FoxPawn(Instigator);
    HoloPRI = NewPRI;
    GearInfo = NewPRI.Loadout.GetCurrentGearInfo();
    UnlockablesDataStore = NewPRI.Loadout.UnlockablesDataStore;
    // End:0x218
    if(GearInfo.AvatarID != -1)
    {
        AvatarProvider = UnlockablesDataStore.AvatarProviderArray[GearInfo.AvatarID];
        AnimSetArray = AvatarProvider.GetAdditionalTPAnimSets();
        I = 0;
        J0x180:
        // End:0x1DB [Loop If]
        if(I < AnimSetArray.Length)
        {
            LowerBodyMesh.AnimSets.AddItem(AnimSetArray[I]);
            ++ I;
            // [Loop Continue]
            goto J0x180;
        }
        GearInfo.bFemale = AvatarProvider.bFemale;
    }
    // End:0x65E
    if(GearInfo.AvatarID == -1)
    {
        // End:0x335
        if(GearInfo.LowerBodyID < UnlockablesDataStore.LowerBodyProviderArray.Length)
        {
            GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.LowerBodyProviderArray[GearInfo.LowerBodyID]);
            LowerBodyMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(GearInfo.bFemale, NewPRI));
        }
        // End:0x4B9
        if(GearInfo.UpperBodyID < UnlockablesDataStore.UpperBodyProviderArray.Length)
        {
            GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.UpperBodyProviderArray[GearInfo.UpperBodyID]);
            UpperBodyMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(GearInfo.bFemale, NewPRI));
            UpperBodyMesh.SetLightEnvironment(LowerBodyMesh.LightEnvironment);
            UpperBodyMesh.SetShadowParent(LowerBodyMesh);
            UpperBodyMesh.SetParentAnimComponent(LowerBodyMesh);
        }
        // End:0x65B
        if(GearInfo.HelmetID < UnlockablesDataStore.HelmetProviderArray.Length)
        {
            GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.HelmetProviderArray[GearInfo.HelmetID]);
            HelmetMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(GearInfo.bFemale, NewPRI));
            HelmetMesh.SetLightEnvironment(LowerBodyMesh.LightEnvironment);
            HelmetMesh.SetShadowParent(LowerBodyMesh);
            LowerBodyMesh.AttachComponentToSocket(HelmetMesh, class'FoxPawn'.default.HelmetSocketName);
        }
    }
    // End:0x73A
    else
    {
        GearInfoProvider = UnlockablesDataStore.AvatarProviderArray[GearInfo.AvatarID];
        LowerBodyMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(GearInfo.bFemale, NewPRI));
        FoxDataProvider_Avatar(GearInfoProvider).SetAvatarSkin(LowerBodyMesh);
    }
    // End:0x8DC
    if(GearInfo.TacticalID < UnlockablesDataStore.TacticalProviderArray.Length)
    {
        GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.TacticalProviderArray[GearInfo.TacticalID]);
        TacticalMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(GearInfo.bFemale, NewPRI));
        TacticalMesh.SetLightEnvironment(LowerBodyMesh.LightEnvironment);
        TacticalMesh.SetShadowParent(LowerBodyMesh);
        LowerBodyMesh.AttachComponentToSocket(TacticalMesh, class'FoxPawn'.default.Gear_TacticalSocketName);
    }
    WeaponMesh = new class'FoxSkeletalMesh3rdPersonHeroWeapon';
    WeaponMesh.SetShadowParent(LowerBodyMesh);
    WeaponMesh.SetLightEnvironment(LowerBodyMesh.LightEnvironment);
    WeaponMesh.UpdateConfigInfo(HoloPRI.Loadout.PrimaryWeaponInfo);
    AttachComponent(WeaponMesh);
    LowerBodyMesh.AttachComponentToSocket(WeaponMesh, 'RightHand');
    LowerBodyMesh.SetAnimTreeTemplate(AnimTreeTemplate);
    AnimCount = ((GearInfo.bFemale) ? FP.FTPAnimSets.Length : FP.MTPAnimSets.Length);
    I = 0;
    J0xA8C:
    // End:0xB68 [Loop If]
    if(I < AnimCount)
    {
        // End:0xB10
        if(GearInfo.bFemale)
        {
            LowerBodyMesh.AnimSets.AddItem(FP.FTPAnimSets[I]);
        }
        // End:0xB5A
        else
        {
            LowerBodyMesh.AnimSets.AddItem(FP.MTPAnimSets[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0xA8C;
    }
    AttachmentClass = HoloPRI.Loadout.PrimaryWeaponInfo.WeaponClass.default.WeaponAttachmentClass;
    AnimSetArray = AttachmentClass.static.GetAnimSets(GearInfo.bFemale);
    I = 0;
    J0xC1E:
    // End:0xCD1 [Loop If]
    if(I < AnimSetArray.Length)
    {
        // End:0xC8E
        if(GearInfo.bFemale)
        {
            LowerBodyMesh.AnimSets.AddItem(AnimSetArray[I]);
        }
        // End:0xCC3
        else
        {
            LowerBodyMesh.AnimSets.AddItem(AnimSetArray[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0xC1E;
    }
    // End:0xDC9
    foreach LowerBodyMesh.AllAnimNodes(class'AnimNodeSlot', Node)
    {
        // End:0xD47
        if(Node.NodeName == FullBodySlotName)
        {
            FullBodyAnimNode = Node;
            // End:0xDC8
            continue;
        }
        // End:0xD89
        if(Node.NodeName == UpperBodySlotName)
        {
            UpperBodyAnimNode = Node;
            // End:0xDC8
            continue;
        }
        // End:0xDC8
        if(Node.NodeName == LowerBodySlotName)
        {
            LowerBodyAnimNode = Node;
        }        
    }    
    // End:0xE7B
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        SetCollision(true, false);
        LowerBodyMesh.SetTraceBlocking(true, true);
        LowerBodyMesh.SetActorCollision(true, false);
        LowerBodyMesh.SetPhysicsAsset(FP.GetPhysAsset(), true);
    }
    SetCamo();
    SetVelocity();
    // End:0xEFE
    if(WorldInfo.MyEmitterPool != none)
    {
        WorldInfo.MyEmitterPool.SpawnEmitter(SpawnInPS, Location,, self);
    }
    //return;    
}

simulated function SetCamo()
{
    local int I, NumTiles;
    local Texture BaseTexture, MetallicTexture;
    local bool bUseBaseColor;
    local float MetallicScalar;
    local LinearColor BaseColor, OverlayColor;
    local MaterialInstanceConstant CurrentMat;
    local LinearColor EmissiveColor;

    EmissiveColor = FoxGRI(WorldInfo.GRI).GetEmissiveColorForTeam(HoloPRI);
    // End:0x2B2
    if(GearInfo.BodyCamoID != 255)
    {
        bUseBaseColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].BaseColor;
        OverlayColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].OverlayColor;
        MetallicScalar = class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].MetallicInterp;
        // End:0x2AF
        if(class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].MetallicTextureSwapRef != "")
        {
            MetallicTexture = Texture(DynamicLoadObject(class'FoxUnlockInfo'.default.BodyCamoUnlocks[GearInfo.BodyCamoID].MetallicTextureSwapRef, class'Texture'));
        }
    }
    // End:0x3A8
    else
    {
        bUseBaseColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].BaseColor;
        OverlayColor = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].OverlayColor;
        MetallicScalar = class'FoxUnlockInfo'.default.BodyCamoUnlocks[0].MetallicInterp;
    }
    class'FoxUnlockInfo'.static.GetBodyCamoTextures(BaseTexture, NumTiles, GearInfo.BodyCamoID);
    I = 0;
    J0x402:
    // End:0x6F3 [Loop If]
    if(I < LowerBodyMesh.GetNumElements())
    {
        CurrentMat = LowerBodyMesh.CreateAndSetMaterialInstanceConstant(I);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoColorOverlayParmName, OverlayColor);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.EmissiveParamName, EmissiveColor);
        // End:0x6E5
        if(GearInfo.AvatarID == -1)
        {
            CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoTextureParmName, BaseTexture);
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoTilesParamName, float(NumTiles));
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            // End:0x64A
            if(bUseBaseColor)
            {
                CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoBaseColorParamName, BaseColor);
            }
            CurrentMat.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0x6E5
            if(MetallicTexture != none)
            {
                CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoMetallicTextureParmName, MetallicTexture);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x402;
    }
    I = 0;
    J0x6FE:
    // End:0x9EF [Loop If]
    if(I < UpperBodyMesh.GetNumElements())
    {
        CurrentMat = UpperBodyMesh.CreateAndSetMaterialInstanceConstant(I);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoColorOverlayParmName, OverlayColor);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.EmissiveParamName, EmissiveColor);
        // End:0x9E1
        if(GearInfo.AvatarID == -1)
        {
            CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoTextureParmName, BaseTexture);
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoTilesParamName, float(NumTiles));
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            // End:0x946
            if(bUseBaseColor)
            {
                CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoBaseColorParamName, BaseColor);
            }
            CurrentMat.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0x9E1
            if(MetallicTexture != none)
            {
                CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoMetallicTextureParmName, MetallicTexture);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x6FE;
    }
    I = 0;
    J0x9FA:
    // End:0xCEB [Loop If]
    if(I < HelmetMesh.GetNumElements())
    {
        CurrentMat = HelmetMesh.CreateAndSetMaterialInstanceConstant(I);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoColorOverlayParmName, OverlayColor);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.EmissiveParamName, EmissiveColor);
        // End:0xCDD
        if(GearInfo.AvatarID == -1)
        {
            CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoTextureParmName, BaseTexture);
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoTilesParamName, float(NumTiles));
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            // End:0xC42
            if(bUseBaseColor)
            {
                CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoBaseColorParamName, BaseColor);
            }
            CurrentMat.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0xCDD
            if(MetallicTexture != none)
            {
                CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoMetallicTextureParmName, MetallicTexture);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x9FA;
    }
    I = 0;
    J0xCF6:
    // End:0xFE7 [Loop If]
    if(I < TacticalMesh.GetNumElements())
    {
        CurrentMat = TacticalMesh.CreateAndSetMaterialInstanceConstant(I);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoColorOverlayParmName, OverlayColor);
        CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.EmissiveParamName, EmissiveColor);
        // End:0xFD9
        if(GearInfo.AvatarID == -1)
        {
            CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoTextureParmName, BaseTexture);
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoTilesParamName, float(NumTiles));
            CurrentMat.SetScalarParameterValue(class'FoxPawn'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            // End:0xF3E
            if(bUseBaseColor)
            {
                CurrentMat.SetVectorParameterValue(class'FoxPawn'.default.CamoBaseColorParamName, BaseColor);
            }
            CurrentMat.SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0xFD9
            if(MetallicTexture != none)
            {
                CurrentMat.SetTextureParameterValue(class'FoxPawn'.default.CamoMetallicTextureParmName, MetallicTexture);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0xCF6;
    }
    //return;    
}

simulated function SetVelocity()
{
    local FoxPawn FP;
    local float GroundSpeed;

    // End:0x141
    if((Physics == 1) && !bIsStationary)
    {
        // End:0x7F
        if(Instigator == none)
        {
            GroundSpeed = class'FoxPawn'.default.GroundSpeed * class'FoxPawn'.default.WalkingPct;
        }
        // End:0xE3
        else
        {
            FP = FoxPawn(Instigator);
            GroundSpeed = FP.GroundSpeed * FP.WalkingPct;
        }
        Velocity = vector(Rotation) * GroundSpeed;
        LowerBodyAnimNode.PlayCustomAnim('RunFWD_A', 1.0, 0.10, 0.10, true, true);
    }
    // End:0x17C
    else
    {
        LowerBodyAnimNode.PlayCustomAnim('Idle_A', 1.0, 0.10, 0.10, true, true);
    }
    //return;    
}

simulated event Landed(Vector HitNormal, Actor FloorActor)
{
    SetPhysics(1);
    SetVelocity();
    //return;    
}

simulated event PlayAnimSet(WeaponAnimSet OutAnims)
{
    local int I;
    local float AnimTime;

    I = 0;
    J0x0B:
    // End:0x332 [Loop If]
    if(I < OutAnims.TP_Anim.AnimName.Length)
    {
        // End:0x324
        if(OutAnims.TP_Anim.AnimName[I] != 'None')
        {
            // End:0x173
            if(I == 0)
            {
                AnimTime = FullBodyAnimNode.PlayCustomAnim(OutAnims.TP_Anim.AnimName[I], OutAnims.RateMultiplier, OutAnims.BlendInTime, OutAnims.BlendOutTime, false, true);
                Velocity = vect(0.0, 0.0, 0.0);
                // [Explicit Break]
                goto J0x332;
            }
            // End:0x240
            if(I == 2)
            {
                AnimTime = UpperBodyAnimNode.PlayCustomAnim(OutAnims.TP_Anim.AnimName[I], OutAnims.RateMultiplier, OutAnims.BlendInTime, OutAnims.BlendOutTime, false, true);
                // [Explicit Break]
                goto J0x332;
            }
            // End:0x324
            if(I == 3)
            {
                AnimTime = LowerBodyAnimNode.PlayCustomAnim(OutAnims.TP_Anim.AnimName[I], OutAnims.RateMultiplier, OutAnims.BlendInTime, OutAnims.BlendOutTime, false, true);
                Velocity = vect(0.0, 0.0, 0.0);
                // [Explicit Break]
                goto J0x332;
            }
        }
        ++ I;
        J0x332:
        // [Loop Continue]
        goto J0x0B;
    }
    SetTimer(AnimTime, false, 'StopAnimSet');
    //return;    
}

simulated function StopAnimSet()
{
    SetVelocity();
    //return;    
}

simulated event byte ScriptGetTeamNum()
{
    // End:0x6B
    if((HoloPRI != none) && HoloPRI.Team != none)
    {
        return byte(HoloPRI.Team.TeamIndex);
    }
    return 255;
    //return ReturnValue;    
}

simulated function PhysicalMaterial GetPawnPhysMatFor(const out ImpactInfo Impact)
{
    return FXMaterial;
    //return ReturnValue;    
}

defaultproperties
{
    begin object name=LowerBodyMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxHoloMan_Base.TPLightEnvironment'
        Scale3D=(X=1.0,Y=1.0,Z=0.0010)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.LowerBodyMeshComponent0'
    LowerBodyMesh=LowerBodyMeshComponent0
    begin object name=UpperBodyMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.UpperBodyMeshComponent0'
    UpperBodyMesh=UpperBodyMeshComponent0
    begin object name=HelmetMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.HelmetMeshComponent0'
    HelmetMesh=HelmetMeshComponent0
    begin object name=TacticalMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.TacticalMeshComponent0'
    TacticalMesh=TacticalMeshComponent0
    begin object name=TPLightEnvironment class=DynamicLightEnvironmentComponent
        MinTimeBetweenFullUpdates=0.30
        VelocityUpdateTimeScale=0.10
        bIsCharacterLightEnvironment=true
        ModShadowFadeoutTime=1.0
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxHoloMan_Base.TPLightEnvironment'
    LightEnvironment=TPLightEnvironment
    GearInfo=(BodyCamoID=255,UpperBodyID=255,LowerBodyID=255,HelmetID=255,BadgeID=0,Gear_R1ID=255,Gear_R2ID=255,Gear_L1ID=255,Gear_L2ID=255,TacticalID=255,ButtPackID=255,bFemale=false,bBot=false,AvatarID=-1,PatchIconID=0,PatchIconColorID=255,PatchShapeID=255,PatchShapeColorID=255,HangerID=-1)
    FullBodySlotName=Custom_FullBody
    UpperBodySlotName=Custom_UpperBody
    LowerBodySlotName=Custom_LowerBody
    GrowTime=0.50
    FXBoneName=Root
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=1.0
        CollisionRadius=30.0
        ReplacementPrimitive=none
        CollideActors=true
    object end
    // Reference: CylinderComponent'Default__FoxHoloMan_Base.CollisionCylinder'
    Components(0)=CollisionCylinder
    begin object name=TPLightEnvironment class=DynamicLightEnvironmentComponent
        MinTimeBetweenFullUpdates=0.30
        VelocityUpdateTimeScale=0.10
        bIsCharacterLightEnvironment=true
        ModShadowFadeoutTime=1.0
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxHoloMan_Base.TPLightEnvironment'
    Components(1)=TPLightEnvironment
    begin object name=UpperBodyMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.UpperBodyMeshComponent0'
    Components(2)=UpperBodyMeshComponent0
    begin object name=HelmetMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.HelmetMeshComponent0'
    Components(3)=HelmetMeshComponent0
    begin object name=LowerBodyMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxHoloMan_Base.TPLightEnvironment'
        Scale3D=(X=1.0,Y=1.0,Z=0.0010)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.LowerBodyMeshComponent0'
    Components(4)=LowerBodyMeshComponent0
    begin object name=TacticalMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxHoloMan_Base.TacticalMeshComponent0'
    Components(5)=TacticalMeshComponent0
    Physics=EPhysics.PHYS_Walking
    RemoteRole=ENetRole.ROLE_SimulatedProxy
    bCollideWorld=true
    LifeSpan=6.0
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=1.0
        CollisionRadius=30.0
        ReplacementPrimitive=none
        CollideActors=true
    object end
    // Reference: CylinderComponent'Default__FoxHoloMan_Base.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}